iv.perpendicular=function(a)// replace to better implementation
{
	var A=Math.abs(a[2]),v;
	if(A<0.7) v=vec3.cross([0,0,1],a);
	else v=vec3.cross([0,1,0],a);
	return v;
}
//frame buffer
iv.framebuffer=function Framebuffer(gl) {
	iv.abstract.call(this);
	this.gl=gl;
	this.buffer=gl.createFramebuffer();
	this.ownDepth=false;
	this.ref=1;
};
iv.framebuffer.prototype=new iv.abstract();
iv.framebuffer.prototype.bind=function() {
	this.gl.bindFramebuffer(this.gl.FRAMEBUFFER,this.buffer);
	return this;
};

iv.framebuffer.prototype.unbind=function() {
	this.gl.bindFramebuffer(this.gl.FRAMEBUFFER,null);
	return this;
};

iv.framebuffer.prototype.check=function() {
	var gl=this.gl,result=gl.checkFramebufferStatus(this.gl.FRAMEBUFFER);
	var str;
	switch(result) {
		case gl.FRAMEBUFFER_UNSUPPORTED: str="FRAMEBUFFER_UNSUPPORTED"; return null;
		case gl.FRAMEBUFFER_INCOMPLETE_ATTACHMENT: str="FRAMEBUFFER_INCOMPLETE_ATTACHMENT"; return null;
		case gl.FRAMEBUFFER_INCOMPLETE_DIMENSIONS: str="FRAMEBUFFER_INCOMPLETE_DIMENSIONS"; return null;
		case gl.FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT: str="FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT"; return null;
	}
	return this;
};

iv.framebuffer.prototype.color=function(colorTexture,t) {
	this.colorTexture=colorTexture;
	var gl=this.gl;
	gl.framebufferTexture2D(gl.FRAMEBUFFER,gl.COLOR_ATTACHMENT0,t||this.colorTexture.target,this.colorTexture.handle,0);
	//this.check();
	return this;
};

iv.framebuffer.prototype.depth=function(depthBuffer) {
	this.depthBuffer=depthBuffer;
	if(this.depthBuffer===void 0) {
		if(this.colorTexture===void 0) {
			return null;
		} else {
			this.ownDepth=true;
			this.depthBuffer=new iv.depthbuffer(this.gl).bind().setSize(this.colorTexture.width,this.colorTexture.height);
		}
	}
	this.gl.framebufferRenderbuffer(this.gl.FRAMEBUFFER,this.gl.DEPTH_ATTACHMENT,this.gl.RENDERBUFFER,this.depthBuffer.id);
	//this.check();
	return this;
};

iv.framebuffer.prototype.destroy=function() {
	this.gl.deleteFramebuffer(this.buffer);
	this.buffer=null;
	if(this.ownDepth)
		return this.depthBuffer.release();//destroy was here
};

iv.renderbuffer=function(gl) {
	iv.abstract.call(this);
	if(gl) {
		this.ref=1;
		this.gl=gl;
		this.id=gl.createRenderbuffer();
	}
}
iv.renderbuffer.prototype=new iv.abstract();

iv.renderbuffer.prototype.bind=function() {
	this.gl.bindRenderbuffer(this.gl.RENDERBUFFER,this.id);
	return this;
};

iv.renderbuffer.prototype.setSize=function(width,height) {
	if(this.width!=width||this.height!=height) {
		this.width=width;
		this.height=height;
		this.bind();
		this.gl.renderbufferStorage(this.gl.RENDERBUFFER,this.format,this.width,this.height);
		return this.unbind();
	} else return this;
};

iv.renderbuffer.prototype.unbind=function() {
	this.gl.bindRenderbuffer(this.gl.RENDERBUFFER,null);
	return this;
};

iv.renderbuffer.prototype.destroy=function() {
	return this.gl.deleteRenderbuffer(this.id);
};

iv.depthbuffer=function(gl) {
	iv.renderbuffer.call(this,gl);
	this.format=gl.DEPTH_COMPONENT16;
}
iv.depthbuffer.prototype=new iv.renderbuffer();

iv.shadowcontext=function(wnd) {
	iv.rcontext.call(this,wnd);
	if(wnd) { this.viewport={ x: 1024,y: 1024 }; this.ortho=false; this.tempV=[]; this.dstMax=0; this.iIndex=0 }
}
iv.shadowcontext.prototype=new iv.rcontext();
iv.shadowcontext.prototype.action=function(n,a,b,c) {
	if(n.state&0x100&&n.object) {
		if(n.object instanceof iv.light) return true;
		if(n.object instanceof iv.camera) return true;
		return n.object.preRender(this,n,a,b,c);
	}
	return true;
}

iv.shadowcontext.prototype.updateImp=function(utm,from,dir,lup,fov) {
	// double check this, utm should be zero, right?
	this.W2=this.viewport.x/2;
	this.H2=this.viewport.y/2;
	var V=this.view;

	if(this.ortho)
	this.screenScale=this.bbScaleFactor=1/(this.H2*V.scale);
		else {
	this.bbScaleFactor=Math.tan(fov)/this.H2;
	this.screenScale=1.0/Math.tan(fov);
	if(utm) {
		this.bbScaleFactor/=utm[0];
		this.screenScale/=utm[0];
	}}
	this.utm=utm;
	if(!from) from=[0,0,0];
	var to=vec3.add(dir,from,[]),up=lup,_up=vec3.add(lup,from,[]);

	if(utm) {
		mat4.lookAt(mat4.mulPoint(utm,from,V.from),mat4.mulPoint(utm,to,V.to),mat4.mulVector(utm,up,V.up),this.mvMatrix);
		mat4.mulPoint(utm,_up,V.up);
	} else mat4.lookAt(from,to,up,this.mvMatrix);

	if(!utm) {
		vec3.cpy(V.from,from);
		vec3.cpy(V.to,to);
		vec3.cpy(V.up,_up);
	}

}

iv.shadowcontext.prototype.update=function(utm,light) {

	this.iIndex=0;
	var w=this.window;
	if(this.version!=w.structVersion) {
		this.version=w.structVersion;
		this.space=w.space;
		this.updateImp(utm,light.org,light.dir,light.up,light.light.outer/2);
		return true;
	}
	return false;
}

iv.shadowcontext.prototype.commonToRenderQueue=function(atm,node,state,opacity) {
	var S=this.space,rmode=S.rmodes[(state&0xff00)>>8],mtl=rmode.mtl||S.cfgDefMtl||node.material;
	if(mtl.opacity&&mtl.opacity.length&&mtl.opacity[0].amount<1.0)
		opacity*=mtl.opacity[0].amount;
	if(opacity<0.2) return null;

	if(atm) return mat4.m(atm,this.mvMatrix,this.tmTmp);
	else return this.mvMatrix;
}
iv.shadowcontext.prototype.commonAdd=function(atm,obj) {
	var _q=this.q[1],a=_q.I[_q.L];
	if(!a) a=_q.I[_q.L]=new iv.queueItem();
	a.tm=atm;
	a.object=obj;
	_q.L++;
}

iv.shadowcontext.prototype.toRenderQueue=function(atm,node,state,opacity) {

	var tm=this.commonToRenderQueue(atm,node,state,opacity);
	if(!tm) return;
	var obj=node.object,_min=obj.boxMin,_max=obj.boxMax,v=this.tempV,S=this.space;

	var far,near,dMax;
	for(var i=0;i<8;i++) {
		v[0]=(i&1)?_max[0]:_min[0],v[1]=(i&2)?_max[1]:_min[1],v[2]=(i&4)?_max[2]:_min[2];
		mat4.mulPoint(tm,v);
		var z=-v[2],l=vec3.length(v);

		if(i) {
			if(z<near) near=z; else if(z>far) far=z;
			if(l>dMax) dMax=l;
		} else { far=near=z; dMax=l; }
	}

	if(far<=0) return;
	if(this.iIndex) {
		if(far>this.zFar) this.zFar=far;
		if(near<this.zNear) this.zNear=near;
		if(dMax>this.dstMax) this.dstMax=dMax;
	} else { this.zFar=far; this.zNear=near; this.dstMax=dMax; }
	this.iIndex++;
	this.commonAdd(atm,obj);
};

// infinite lights
iv.infshadowcontext=function(wnd) {
	iv.shadowcontext.call(this,wnd);
	this.ortho=true;
}
iv.infshadowcontext.prototype=new iv.shadowcontext();

iv.infshadowcontext.prototype.update=function(utm,light) {
	var rez=iv.shadowcontext.prototype.update.call(this,utm,light);
	if(rez) {
		this.box=[];
	}
	return rez;
}

iv.infshadowcontext.prototype.updateVolume=function() {
	var b=this.box;
	this.zFar=b[5];
	this.zNear=b[4];
};


iv.infshadowcontext.prototype.toRenderQueue=function(atm,node,state,opacity) {
	var tm;
	if(atm) tm=mat4.m(atm,this.mvMatrix,this.tmTmp);
	else tm=this.mvMatrix;
	var obj=node.object,_min=obj.boxMin,_max=obj.boxMax,S=this.space;
	var v=this.tempV,j=this.iIndex,b=this.box;

	for(var i=0;i<8;i++) {
		v[0]=(i&1)?_max[0]:_min[0],v[1]=(i&2)?_max[1]:_min[1],v[2]=(i&4)?_max[2]:_min[2];
		mat4.mulPoint(tm,v);
		if(j) {
			var J=0;
			for(var k=0;k<3;k++) {
				var x=v[k];
				if(x<b[J]) b[J]=x;
				J++;
				if(x>b[J]) b[J]=x;
				J++;
			}
		} else {
			b[0]=b[1]=v[0];
			b[2]=b[3]=v[1];
			b[4]=b[5]=this.near=v[2];// do we need near here
		}
		j++;
	}
	this.iIndex=j;
	var rmode=S.rmodes[(state&0xff00)>>8],mtl=rmode.mtl||S.cfgDefMtl||node.material;
	var _q=this.q[1],a=_q.I[_q.L];

	if(!a) a=_q.I[_q.L]=new iv.queueItem();
	a.tm=atm;
	a.object=obj;
	a.state=state|(node.state&(16|32|0x70000|0x300));
	a.opacity=opacity;
	_q.L++;
};


iv.space.prototype.getFloatExtenson=function(spec) {
	if(this.e_float_texture===undefined) {
		if(!spec) spec={ prefer: ["filterable","half"],require: ["renderable"] };
		var gl=this.gl;
		var candidate,candidates,half,halfFramebuffer,halfLinear,halfTexture,i,importance,preference,result,single,singleFramebuffer,singleLinear,singleTexture,use,_j,_k,_l,_len1,_len2,_len3,_len4,_m,_ref,_ref1,_ref2,_ref3,_ref4,_ref5;
		if((_ref=spec.prefer)==null)
			spec.prefer=['half'];

		if((_ref1=spec.require)==null)
			spec.require=[];

		singleTexture=this.getExtension('OES_texture_float');
		halfTexture=this.getExtension('OES_texture_half_float');
		singleFramebuffer=this.getExtension('WEBGL_color_buffer_float');
		halfFramebuffer=this.getExtension('EXT_color_buffer_half_float');
		singleLinear=this.getExtension('OES_texture_float_linear');
		halfLinear=this.getExtension('OES_texture_half_float_linear');

		single={
			texture: singleTexture!==null,
			filterable: singleLinear!==null,
			renderable: singleFramebuffer!==null,
			score: 0,
			precision: 'single',
			half: false,
			single: true,
			type: this.FLOAT
		};
		half={
			texture: halfTexture!==null,
			filterable: halfLinear!==null,
			renderable: halfFramebuffer!==null,
			score: 0,
			precision: 'half',
			half: true,
			single: false,
			type: (_ref3=halfTexture!=null?halfTexture.HALF_FLOAT_OES:void 0)!=null?_ref3:null
		};
		candidates=[];
		if(single.texture) candidates.push(single);
		if(half.texture) candidates.push(half);

		result=[];
		for(_j=0,_len1=candidates.length;_j<_len1;_j++) {
			candidate=candidates[_j];
			use=true;
			_ref4=spec.require;
			for(_k=0,_len2=_ref4.length;_k<_len2;_k++) {
				name=_ref4[_k];
				if(candidate[name]===false) use=false;

			}
			if(use) result.push(candidate);

		}
		for(_l=0,_len3=result.length;_l<_len3;_l++) {
			candidate=result[_l];
			_ref5=spec.prefer;
			for(i=_m=0,_len4=_ref5.length;_m<_len4;i=++_m) {
				preference=_ref5[i];
				importance=Math.pow(2,spec.prefer.length-i-1);
				if(candidate[preference]) {
					candidate.score+=importance;
				}
			}
		}
		result.sort(function(a,b) {
			if(a.score===b.score)
				return 0;
			else if(a.score<b.score)
				return 1;
			else if(a.score>b.score)
				return -1;
		});
		if(result.length) {
			result=result[0];
			this.e_float_texture={
				filterable: result.filterable,
				renderable: result.renderable,
				type: result.type,
				precision: result.precision
			};
		} else this.e_float_texture=null;
	}
	return this.e_float_texture;
}

iv.mesh.prototype.renderShadow=function(space,info){
	if(this.vBuffer) {
		var gl=space.gl;
		var fb=this.fBuffer;
		if(fb) {
			var b=this.vBuffer;
			if(b) {
				gl.bindBuffer(gl.ARRAY_BUFFER,b);
				var slot=0;
				gl.vertexAttribPointer(slot,b.itemSize,gl.FLOAT,false,0,0);// where f
			}

			gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER,fb);
			var o=fb.offset;
			gl.drawElements(gl.TRIANGLES,fb.numItems,gl.UNSIGNED_SHORT,o?o:0);
		}
	}
}

iv.space.prototype.shadowRenderQueue_=function(items,shader) {
	var c=items.length,a,b,gl=this.gl;
	for(var i=0;i<c;i++) {
		b=items[i];

		gl.uniformMatrix4fv(shader.shaderTM,false,b.tm);
		b.object.renderShadow(this,b);
	};
}

iv.space.prototype.shadowMakeShader=function(type) {
	var gl=this.gl;
	var vt='varying vec4 pnt;attribute vec3 position;uniform mat4 tm,lightTm,projection;void main(){ pnt = lightTm*tm * vec4(position, 1.0);gl_Position = projection * pnt;}';
	var ft;
	switch(type) {
		case 1: ft='precision mediump float;varying vec4 pnt;uniform vec4 bias;void main(){gl_FragColor=vec4(vec3(pnt.z*bias.x+bias.y),1.0);}'; break;
		case 2: ft='precision mediump float;varying vec4 pnt;uniform vec4 bias;void main(){vec3 pos=pnt.xyz;float depth=length(pos)*bias.x+bias.y;gl_FragColor = vec4(vec3(depth), 1.0);}'; break;
	}

	var vShader=this.compileShader(vt,gl.VERTEX_SHADER),fShader=this.compileShader(ft,gl.FRAGMENT_SHADER),shPrg=gl.createProgram();

	gl.attachShader(shPrg,vShader);
	gl.attachShader(shPrg,fShader);
	gl.linkProgram(shPrg);

	if(!gl.getProgramParameter(shPrg,gl.LINK_STATUS)) {
		alert("Could not initialise shaders");
	}

	var sh={};
	sh.shader=shPrg;
	sh.vShader=vShader;
	sh.fShader=fShader;
	gl.useProgram(shPrg);

	sh.shaderTM=gl.getUniformLocation(shPrg,"tm");
	sh.shaderLightTM=gl.getUniformLocation(shPrg,"lightTm");
	sh.shaderPrjTM=gl.getUniformLocation(shPrg,"projection");
	sh.shaderLightBias=gl.getUniformLocation(shPrg,"bias");

	gl.useProgram(null);
	return sh;
};


iv.space.prototype.shadowDoneMap=function(l) {
	if(l.lightFramebuffer) { l.lightFramebuffer.release(); l.lightFramebuffer=null; }
	if(l.lightDepthTexture) { l.lightDepthTexture.release(); l.lightDepthTexture=null; }
	if(l.shadowBias) l.shadowBias=null;
	if(l.context) l.context=null;
	if(l.shaders) {
		for(var i=0;i<l.shaders.length;i++) l.shaders[i].valid=false;
		l.shaders=null;
	}
	l.structVersion=-1;
}


iv.space.prototype.shadowPrecheckMapTextures_=function(l) {
	var efloat=this.getFloatExtenson();
	if(efloat) {
		if(!l.lightDepthTexture) {
			var txt=new iv.texture(this.gl,{ type: efloat.type });
			var size=l.light.mapSize;
			txt.bind().setSize(size,size).clampToEdge();
			l.lightDepthTexture=txt;
			if(efloat.filterable) txt.linear(); else txt.nearest();
		}
		if(!l.lightFramebuffer)
			l.lightFramebuffer=new iv.framebuffer(this.gl).bind().color(l.lightDepthTexture).depth().unbind();
		return l.lightFramebuffer!=null;
	}
	return false;
}

iv.space.prototype.shadowPrecheckMapTextures_cube=function(l) {
	var efloat=this.getFloatExtenson();
	if(efloat) {
		var gl=this.gl;
		if(!l.lightDepthTexture) {
			var txt=new iv.texture(gl,{ target: gl.TEXTURE_CUBE_MAP,type: efloat.type });
			var size=l.light.mapSize;
			txt.bind();
			//txt.setSize(size,size);

			this.width=size;
			this.height=size;
			var s=this.getCubeInfo();
			for(var i=0;i<s.length;i++)
				this.gl.texImage2D(s[i].id,0,txt.channels,size,size,0,txt.channels,txt.type,null);
			txt.width=size;
			txt.height=size;

			txt.clampToEdge();
			if(efloat.filterable) txt.linear(); else txt.nearest();
			l.lightDepthTexture=txt;
		}

		if(!l.lightFramebuffer) {
			l.lightFramebuffer=new iv.framebuffer(gl);
		}

		return l.lightFramebuffer!=null;
	}
	return false;
}
iv.space.prototype.shadowRenderQueue=function(ctx,shader) {
	for(var i=1;i<ctx.q.length;i++) {
		var q=ctx.q[i],L=q.L;
		if(!L) continue;
		var _i=q.I;
		if(_i.length>q.L) _i.splice(q.L,_i.length-q.L);
		this.shadowRenderQueue_(_i,shader);
		q.L=0;
	}
};

iv.space.prototype.shadowClearSurface=function(a){
	var gl=this.gl;
	gl.clearColor(a,1,1,1);
	gl.clear(gl.COLOR_BUFFER_BIT|gl.DEPTH_BUFFER_BIT);
}

iv.space.prototype.shadowRenderMap_01=function(l,shader) {
	var gl=this.gl;
	this.shadowClearSurface(1.0);
	gl.uniformMatrix4fv(shader.shaderPrjTM,false,l.projectionTM);
	gl.uniformMatrix4fv(shader.shaderLightTM,false,l.lightTm);
	gl.uniform4fv(shader.shaderLightBias,l.shadowBias);
}

iv.space.prototype.shadowApplyBias=function(l) {
	// additional bias   
	if(l.shadowBias) {
		var bias=l.light.shadowBias*0.0005;
		l.shadowBias[1]-=bias;
	}
}

iv.space.prototype.shadowInitBias=function(l,near,far) {
	var k=far-near;
	if(k) k=1.0/k;
	l.shadowBias=[k,-near*k,l.light.shadowAmount,l.light.shadowBias*0.0015];
}

iv.space.prototype.shadowRenderMap=function(l,shader){
	var gl=this.gl;
	l.lightFramebuffer.bind();
	gl.viewport(0,0,l.lightDepthTexture.width,l.lightDepthTexture.height);
	gl.useProgram(shader.shader);
	this.shadowRenderMap_01(l,shader);
	gl.enableVertexAttribArray(0);
	this.shadowRenderQueue(l.context,shader);
	gl.disableVertexAttribArray(0);
	gl.useProgram(null);
	l.lightFramebuffer.unbind();
	l.lightDepthTexture.ready=true;
}

iv.space.prototype.shadowRenderSides=function(l,shader) {
	var ctx=l.context;
	var gl=this.gl;

	var sides=this.getCubeInfo();

	var ctxs=[];
	var near,far,_far,count=0,fov=Math.PI/4;   // 45deg =90/2
	var utm=this.unitMatrix;

	for(var i=0;i<6;i++) {
		var s=sides[i];
		var ctx=new iv.shadowcontext(this.window);
		ctx.space=this;
		ctx.viewport=new iv.size();
		ctx.viewport.x=l.lightDepthTexture.width;
		ctx.viewport.y=l.lightDepthTexture.height;
		ctx.updateImp(null,l.org,s.dir,s.up,fov);    // no utm
		this.root.traverse(ctx,utm,32,1.0);

		if(ctx.iIndex) {
			ctxs[i]=ctx;
			if(count) {
				if(near>ctx.zNear) near=ctx.zNear;
				if(far<ctx.zFar) far=ctx.zFar;
				if(ctx.dstMax>_far) _far=ctx.dstMax;
			} else {
				near=ctx.zNear;
				far=ctx.zFar;
				_far=ctx.dstMax;
			}
			count++;
		}
	}
	// to do - check for far/near range!!!!

	var fb=l.lightFramebuffer;


	fb.bind();
	if(count) {
		var d=far-near;
		d/=100; far+=d; near-=d;// some guard distance
		d=far/1000;
		if(near<d) near=d;
		mat4.perspective(fov,1.0,near,far,l.projectionTM);
		//var k=_far-near;
		//if(k) k=1.0/k;
		//l.shadowBias=[k,near,l.light.shadowAmount,_far];
		this.shadowInitBias(l,near,_far);
	}

	gl.viewport(0,0,l.lightDepthTexture.width,l.lightDepthTexture.height);
	gl.useProgram(shader.shader);
	gl.enableVertexAttribArray(0);

	for(var i=0;i<6;i++) {
		var ctx=ctxs[i];
		var glid=sides[i].id;
		fb.color(l.lightDepthTexture,glid);

		if(!fb.depthBuffer) fb.depth();

		if(ctx) l.lightTm=ctx.mvMatrix;// we don't need this, later
		if(ctx) {
			l.lightTm=ctx.mvMatrix;// we don't need this, later
			this.shadowRenderMap_01(l,shader);
			this.shadowRenderQueue(ctx,shader);
		}
		else this.shadowClearSurface(0.7);
	}
	gl.disableVertexAttribArray(0);
	gl.useProgram(null);
	l.lightFramebuffer.unbind();
	l.lightDepthTexture.ready=true;
	fb.unbind();
}
iv.space.prototype.shadowUpdateMap=function(l){
	var wnd=this.window;
	if(l.structVersion==wnd.structVersion) return l.shadowOK;

	l.structVersion=wnd.structVersion;
	var rezult=false;

	if((l.type)) l.up=iv.perpendicular(l.dir);
	if(!l.projectionTM) l.projectionTM=[];

	var sh=this.shadows;
	if(!sh) sh=this.shadows=this.shadows={};
	var unit=this.unitMatrix;

	var gl=this.gl,back=l.light.shadowBackFaces;
	if(back) { gl.cullFace(gl.FRONT); gl.enable(gl.CULL_FACE); }

	switch(l.type) {
		//point lights
		case 0: if(this.shadowPrecheckMapTextures_cube(l)) {
			if(!sh.shader2) sh.shader2=this.shadowMakeShader(2);
			this.shadowRenderSides(l,sh.shader2);
			rezult=true;
			//ctx.update(unit,l);
		} break;
		//infinite lights
		case 1: if(this.shadowPrecheckMapTextures_(l)){
			if(!l.context)
				l.context=new iv.infshadowcontext(this.window);
			var ctx=l.context;
			ctx.update(unit,l);
			l.lightTm=ctx.mvMatrix;
			this.root.traverse(ctx,unit,32,1.0);
			ctx.updateVolume();
			var sx=ctx.box[1]-ctx.box[0],sy=ctx.box[3]-ctx.box[2],_max=Math.max(sx,sy),d=(_max-Math.min(sx,sy))/2,dx=0,dy=0;
			if(sx<sy)dx=d;else dy=d;// make volume uniform
			l.projectionWidth=_max;
			mat4.ortho(ctx.box[0]-dx,ctx.box[1]+dx,ctx.box[2]-dy,ctx.box[3]+dy,-ctx.box[5],-ctx.box[4],l.projectionTM);
			ctx.zNear=ctx.box[5];
			ctx.zFar=ctx.box[4];
			sx=_max/l.lightDepthTexture.width;
			l.uvV=vec3.scale(l.up,sx,[]);
			l.uvU=vec3.scale(vec3.crossN(l.dir,l.up,[]),sx);

			if(!sh.shader1) sh.shader1=this.shadowMakeShader(1);
			this.shadowInitBias(l,ctx.zNear,ctx.zFar);
			this.shadowRenderMap(l,sh.shader1);
			rezult=true;
		} break;
		//spot
		case 2: if(this.shadowPrecheckMapTextures_(l)) {
			if(!l.context) l.context=new iv.shadowcontext(this.window);
			var ctx=l.context;
			ctx.update(null,l);
			l.lightTm=ctx.mvMatrix;
			this.root.traverse(ctx,unit,32,1.0);
			if(ctx.iIndex) {
				mat4.perspectiveEx(l.light.outer/2,1,ctx.zNear,ctx.zFar,l.projectionTM);
				rezult=true;
				if(!sh.shader2) sh.shader2=this.shadowMakeShader(2);
				this.shadowInitBias(l,ctx.zNear,ctx.dstMax);
				this.shadowRenderMap(l,sh.shader2);
				var sx=1.0/l.lightDepthTexture.width;
				l.uvV=vec3.scale(l.up,sx,[]);
				l.uvU=vec3.scale(vec3.crossN(l.dir,l.up,[]),sx);
			}
		} break;
	}
	if(back) { gl.cullFace(gl.BACK); gl.disable(gl.CULL_FACE); }
	this.shadowApplyBias(l);

	l.shadowOK=rezult;
	return rezult;
}

iv.space.prototype._checkTexture=function(targetType) {
	var t=new iv.texture(this.gl,{ type: targetType });
	t.bind().setSize(2,2);
	var rez=this.gl.getError()===0;
	t.unbind().release();
	return rez;
};

iv.space.prototype._checkColorBuffer=function(type){
	var txt=new iv.texture(this.gl,{ type: type });
	txt.bind().setSize(2,2);
	var fb=new iv.framebuffer(this.gl),check=fb.bind().color(txt).check();
	fb.unbind();
	txt.unbind();
	fb.release();
	txt.release();
	return check!=null;
}

iv.space.prototype.composeExtension=function(e){
	switch(e) {
		case 'OES_texture_half_float': {
			if(this._checkTexture(0x8D61))
				return { composite: true,HALF_FLOAT_OES: 0x8D61 };
		} break;
		case 'EXT_color_buffer_half_float':
			{
				var et=this.getExtension('OES_texture_half_float');
				if(et&&this._checkColorBuffer(et.HALF_FLOAT_OES))
					return { composite: true,RGBA16F_EXT: 0x881A,RGB16F_EXT: 0x881B,FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE_EXT: 0x8211,UNSIGNED_NORMALIZED_EXT: 0x8C17 };
			}
	}
	return null;
};
