/*FULL SCREEN VIEWER*/

iv.onResize=function(v)
 {
 
  var width = window.innerWidth;
  var height=window.innerHeight;
  var e = window.devicePixelRatio || 1;   
  v.setViewSize(width,height,width*e,height*e);
  var s=v.progress.div.style;
  s.left=(width-100)/2+'px';
  s.top=(height-100)/2+'px';
  iv.udpateMenu(v);
}

iv.initViewer3d=function(file,bk,path,size)
{
  var canvas=document.getElementById("ivwindow3d");

  var v=new iv.window({canvas:canvas,color:bk});
  iv.uiScale=size;
  v.rmodes=[//render modes
	{"f":true,"n":true,"e":false,"mtl":null},//solid mode
	{"f":false,"n":true,"e":true,"mtl":null},//wireframe
    ];
  var divP=document.createElement("div");
  divP.className="dprogress";  

  var d=document.createElement("div"),c=null;
  d.innerHTML='<svg id="progress" class="cprogress" width="100" height="100" viewPort="0 0 50 50" version="1.1" xmlns="http://www.w3.org/2000/svg"><circle id="bar" r="45" cx="50" cy="50" fill="transparent" stroke-dasharray="282.743" stroke-dashoffset="0" transform="rotate(-90 50 50) "></circle></svg>';
  c=iv.getSubElementById(d,"progress");
  if(c && c.children)c=c.children[0];

  divP.appendChild(d);
  var div2=document.createElement("div");
  div2.className="tprogress";  
  var text=document.createElement("div");
  text.className="textProgress";
  text.innerHTML="0%";
  div2.appendChild(text);
  divP.appendChild(div2);

  canvas.parentElement.appendChild(divP); 

  v.progress={circle:c,text:text,div:d?d.parentElement:null};
  window.onresize = function(){iv.onResize(v);};

  v.progress.div.style.display="inline-block";
  v.addRefTarget(function(a)
	{
	  switch(a.code)
	{
	case "dataReady":v.progress.div.style.display="none";
			v.fillTree();
			var panel=document.getElementById("panel.main");
			if(v.menuOpen)iv.menuOpen=true;
			if(v.cfgSelZOffset)v.space.cfgSelZOffset=true;
			var rmode="solid";
			v.setRMode(rmode);
                        iv.updateButtonsRM(rmode);

			iv.udpateMenu(v);
                        break;
	case "progress":
	   var i=a.loaded/a.total;
	   if(v.progress.circle)v.progress.circle.style.strokeDashoffset=45*Math.PI*2.0*(1.0-i);  
	   v.progress.text.innerHTML=Math.round(i*100).toString()+"%";
        break;
    case "selection":{
        v.treeView.onNodeSelected(a.node);

		break;
	}

	}});

  iv.onResize(v);
  v.load(file||"tree.iv3d",path);
  return v;
 
}


iv.window.prototype.onCommand=function(id,extra)
{
    switch(id)
    {
	case "cm_object":this.space.select(extra,true,false);break;
        case "cm_solid":this.setRenderMode(0);break;
        case "cm_wire":this.setRenderMode(1);break;
        case "cm_left":this.setStdView("left",iv.VIEW_TRANSITION);break;
        case "cm_right":this.setStdView("right",iv.VIEW_TRANSITION);break;
        case "cm_top":this.setStdView("top",iv.VIEW_TRANSITION);break;
        case "cm_front":this.setStdView("front",iv.VIEW_TRANSITION);break;
        case "cm_back":this.setStdView("back",iv.VIEW_TRANSITION);break;

        case "cm_bottom":this.setStdView("bottom",iv.VIEW_TRANSITION);break;
        case "cm_top":this.setStdView("top",iv.VIEW_TRANSITION);break;

        case "cm_home":this.setDefView(iv.VIEW_TRANSITION);break;
        case "cm_fit":this.zoomToFit(null,iv.VIEW_TRANSITION);break;
        case "cm_view":this.setModelView(extra);break;
        case "cm_cam":
        if(extra)
        {
	var n=extra;
        var c=n.camera;
        var wtm=n.getWTM();
        var d={from:c.from.slice(),to:c.to.slice(),up:c.up.slice()};
        if(wtm)
        {
            mat4.mulPoint(wtm,d.from);
            mat4.mulPoint(wtm,d.to);
            mat4.mulPoint(wtm,d.up);
        }
	    if(c.fov)d.fov=c.fov;else d.fov=this.fov;
        this.setView(d,iv.VIEW_TRANSITION);
                       }break;
    }
};

iv.window.prototype.fillTree=function()
{
    var panel=document.getElementById("panel");
    var views=iv.getSubElementById(panel,"views");
    var objects=iv.getSubElementById(panel,"tree");
    var addItem=function(wnd,p,name,id,extra)
    {
    	var li=document.createElement("li");
        li.innerHTML=name;
   	li.id=id;
        li.onclick=function(event)
        {
           wnd.onCommand(id,extra);
        };
     p.appendChild(li);
    }

    var enumCameras=function(n,d)
    {
        if(n.camera)
        {
            //if(d.sep){d.menu.addSeparator();d.sep=false;}
            var name=n.name;
            if(!name)name="Camera";
            d.addItem(d.wnd,d.v,name,"cm_cam",n);
        }
        n=n.firstChild;
        while(n)
        {
            enumCameras(n,d);
            n=n.next;
        }
    };

    var wnd=this;	

    addItem(this,views,"Left","cm_left");
    addItem(this,views,"Right","cm_right");    
    addItem(this,views,"Top","cm_top");
    addItem(this,views,"Bottom","cm_bottom");
    addItem(this,views,"Front","cm_front");
    addItem(this,views,"Back", "cm_back");
    var s=wnd.space;
   

    if(s)
    {
        var d={wnd:this,v:views,addItem:addItem,sep:true};
        if(s.views)
        {
            for(var i=0;i<s.views.length;i++)
            {
                var v=s.views[i];
                var name=v.name;
                if(!name)name="View "+(i+1);
                addItem(this,views,name,"cm_view",i);
            }
        }
        enumCameras(s.root,d);
    }

    addItem(this,views,"Home","cm_home");
    addItem(this,views,"Fit All","cm_fit");

    this.treeView=new iv.treeView(objects,this,16*iv.uiScale);
    this.treeView.init(this.space);
}


iv.window.prototype.getRenderMode=function()
{
    var n=this.space.root;
    if(n)
    {
        var mode=n.state&0xff00;
        mode>>=8;
        return mode;
    }
    return 0;
}
iv.window.prototype.setRenderMode=function(mode)
{
    if(!this.mtlWireframe){
        this.modeWireframe=  this.space.rmodes.length;
        var m=this.space.newMaterial();
        this.mtlWireframe=m;
        m.load({ diffuse: { color: 0x303030 },specular: { color: 0x808080 },emissive: { color: 0x0 } ,opacity: { amount: 0.5 }});
        this.space.rmodes.push({"f":false,"n":false,"e":true,"mtl":m});   
    }
    var n=this.space.root;
    if(n){
    n.state&=~0xff00;
    if(mode)
        n.state|=(this.modeWireframe<<8);
    this.invalidate(); 
    }
}

iv.getSubElementById=function( dNode, id ) {
	var dResult = null;
	if ( dNode.getAttribute('id') == id )
		return dNode;
	for ( var i = 0; i < dNode.childNodes.length; i++ ) {
		if ( dNode.childNodes[i].nodeType == 1 ) {
			dResult = iv.getSubElementById( dNode.childNodes[i], id );
			if ( dResult != null )
				break;
		}
	}
	return dResult;
}


iv.menuOpen=false;
iv.udpateMenu=function(v)
{
  var scale=iv.uiScale;
  var sp=function(item,x,y)
{
  if(typeof item==="string")item=document.getElementById(item);
  if(item)
  {
     if(x!==undefined)item.style.left=""+scale*x+"px";
     if(y!==undefined)item.style.top=""+y+"px";
  }
}
  var panel=document.getElementById("panel");
  var content=document.getElementById("content");

  var buttons=document.getElementById("buttons");

  var w=300;
  var offset=20;
  var textPos=offset;
  sp(content,0,50*scale);
  panel.style.height="100%";
  panel.style.width=""+w*scale+"px";
  content.style.width=""+w*scale+"px";
  buttons.style.width=""+(w-10)*scale+"px";
  if(iv.menuOpen)
  {
     sp("main.button",w-offset-20,offset);
     sp("main.text",offset,textPos);
     sp(panel,0,0);
     
  }else
  {
     sp("main.button",offset,offset);
     sp("main.text",offset+30,textPos);
     sp(panel,-(w*1.1),0);
     
  }
}
iv.updateButtonsRM=function(id)
{
var rms=["solid","wire","hiddenwire","illustration","wireshaded","outline"];
var a='view3d-rm-';
id=a+id;
 for(var i=0;i<rms.length;i++)
 {
   var b=a+rms[i];
     var button=document.getElementById(b);
    if(button)button.className=(b===id)?'active':'passive';
   //iv.setCheckMenu2(b,id);
 }
}

iv.setRMode=function(menu)
{
  var id=menu.id;
  var _id=id.substring(10,id.length);
  view3d.setRMode(_id);
  iv.updateButtonsRM(_id);
}
iv.toggleMenu=function()
{
  iv.menuOpen=!iv.menuOpen;
  iv.udpateMenu();
};
